TYPOS.Flow - Bug # 34872

Status: Resolved Priority: Must have
Author: Karsten Dambekalns Category: Validation
Created: 2012-03-15 Assigned To: Adrian Foder
Updated: 2013-04-05 Due date:

PHP Version:

Has patch: No

Complexity:

Affected Flow version: FLOW3 1.0.3

Subject: Singleton validators never have their options passed

Description

The ValidatorResolver does not pass options to validators that are singletons:

case Configuration::SCOPE_PROTOTYPE:
$validator = new $validatorObjectName($validatorOptions);
break;

case Configuration::SCOPE_SINGLETON:
$validator = $this->objectManager->get($validatorObjectName);
break;

Since singletons cannot get constructor arguments via get() but only through object configuration, we should at least check for options
given to a singleton here and inform the developer about a probably bug in his code...

Associated revisions

Revision 5f1f59bd - 2013-01-23 17:54 - Adrian Foder

[BUGFIX] Throw exception when using options with singleton validators
Validators being singleton must not be called with options because

the options are then inherent properties of the Validator and cannot

be executed subsequently with other options.

An exception is thrown if such a case occurs because it is then
a design mistake of the developer.

Besides, this improves the namespace use a bit.

Change-Id: 14a7dbaaaf8fa39a3f4677bb43db044a3231b843f

Releases: master, 2.0

Fixes: #34872

Revision 05fc389b - 2013-04-05 10:27 - Adrian Foder

[BUGFIX] Throw exception when using options with singleton validators

Validators being singleton must not be called with options because
the options are then inherent properties of the Validator and cannot

be executed subsequently with other options.

An exception is thrown if such a case occurs because it is then
a design mistake of the developer.

Besides, this improves the namespace use a bit.
Change-Id: 14a7dbaaaf8fa39a3f4677bb43db044a3231b843f

Releases: master, 2.0
Fixes: #34872

History

#1 - 2012-04-18 22:49 - Karsten Dambekalns
- Target version changed from 1.0.4 to 1.0.5

#2 - 2012-06-05 21:20 - Karsten Dambekalns
- Target version changed from 1.0.5 to 1.1 RC1

#3 - 2012-06-25 22:21 - Karsten Dambekalns
- Status changed from Accepted to New

- Assigned To deleted (Karsten Dambekalns)

- Target version deleted (1.1 RC1)

#4 - 2013-01-23 17:21 - Karsten Dambekalns

- Subject changed from Singleton validators do not get their options to Singleton validators have never passed their options

#5 - 2013-01-23 17:22 - Karsten Dambekalns

- Subject changed from Singleton validators have never passed their options to Singleton validators never have their options passed

#6 - 2013-01-23 17:25 - Adrian Foder

- Status changed from New to Accepted

- Assigned To set to Adrian Foder

- Target version set to 2.0

- Affected Flow version changed from FLOW3 1.0.3 to Git master

#7 - 2013-01-23 17:41 - Karsten Dambekalns

Why did you change the affected version?

#8 - 2013-01-23 17:52 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.

It is available at https://review.typo3.org/17671

#9 - 2013-01-23 17:53 - Adrian Foder
- Affected Flow version changed from Git master to FLOW3 1.0.3
https://review.typo3.org/17671

sorry didn't want to change it but was used to click "git any" at that box, without reading a present value...

#10 - 2013-01-23 17:55 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/17671

#11 - 2013-04-05 10:32 - Gerrit Code Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/19562

#12 - 2013-04-05 11:38 - Adrian Féder
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:05fc389ba3bf7022960cfd6cd9f66f1f82732f11.
